<template>
  <article class="view view--identity-account-password-change">
    <VForm
      name="account-password-change-form"
      :fields="fields"
      :modelState="modelState"
      buttonText="Change"
      buttonIconClass="bi bi-save-fill"
      :busy="saving"
      busyButtonText="Changing..."
      :error="errorDescription"
      @input="onInput"
      @submit="onSubmit"
    />
  </article>
</template>

<script>
import { ref } from 'vue'
import { VForm, useApi, useNotification } from '../../../core'
import AccountApi from '../../api/account-api.js'
import { useAuth } from '../../plugins/auth-plugin.js'

export default {
  name: 'IdentityAccountPasswordChangeView',
  components: {
    VForm,
  },
  setup() {
    const api = useApi()
    const auth = useAuth()
    const notify = useNotification()
    const accountApi = new AccountApi(api, auth)

    const fields = ref([
      {
        type: 'password',
        name: 'currentPassword',
        label: 'Current password',
        validate: 'required',
        maxlength: 200,
        value: '',
      },
      {
        type: 'password',
        name: 'newPassword',
        label: 'New password',
        validate: 'required',
        maxlength: 200,
        value: '',
      },
    ])

    const modelState = ref({})
    const errorDescription = ref('')
    const saving = ref(false)

    const onInput = () => {
      errorDescription.value = ''
    }

    const onSubmit = async (form) => {
      modelState.value = {}
      errorDescription.value = ''
      saving.value = true

      try {
        await accountApi.changePasswordAsync({
          currentPassword: form.currentPassword,
          newPassword: form.newPassword,
        })

        notify.success('Password successfully changed.')
      } catch (ex) {
        if (ex.response.data?.modelState) {
          modelState.value = ex.response.data.modelState
        } else if (ex.response.data?.message) {
          errorDescription.value = ex.response.data.message
        } else {
          notify.error('There was a problem changing your password.', ex)
        }
      } finally {
        saving.value = false
      }
    }

    return {
      fields,
      modelState,
      errorDescription,
      saving,
      onInput,
      onSubmit,
    }
  },
}
</script>
